;-   
;Timer 0  10 
;Timer 1      T1 (PD5 . 9)
;   UART   10   Led (PB0 .12)
; Test-kalibr_peredat.png

.device ATtiny2313
; 2.097152  
;  Led   12 (PB0)
.include "tn2313def.inc"

.def temp = r16 ; 
.def data0 = r17
.def data1 = r18 
.def data2 = r19 ;data2:data1:data0 -       
.def count_0 = r20 ;  Timer 0
.def count_sek = r21 ; 
.def Flag_out = r22 ;    
 
 ;===  ====
 rjmp RESET ;Reset Handle
.org OVF1addr ;ovfow Timer1
	rjmp TIM1_OVF
.org OVF0addr ;ovfow Timer0
	rjmp TIM0_OVF
;====================

TIM0_OVF: ; 8 Hz  2.097152 ; 15.26   4 
   inc count_0
	cpi count_0,80 ;8 = 1 sek; 10 sek =  80  2.097152 
	 breq end_8 ; 10  o,   
	reti ;  
end_8: ; , 
 clr temp
 out TCCR1B,temp ; Timer1 
; 
 in data0,TCNT1L  ;  
 in data1,TCNT1H  ;  
 ldi Flag_out,$FF ; 
;===   
 clr temp
 out TCNT1H,temp 
 out TCNT1L,temp ; Timer1
 out TCNT0,temp ; Timer0    
	 clr count_0 ; 
;===   
 ldi temp,0b00000110 ;Timer1   1 (. 9 PD5)  
 out TCCR1B,temp ; Timer1
;=== 
	 inc count_sek
	 mov temp,count_sek 
	 andi temp,0x01 
	 tst temp
	 brne off_led ;  -  
		sbi PortB,0 ; -  Led
	 reti 
off_led:
		cbi PortB,0 ; -  Led
reti

TIM1_OVF:
  inc data2 ;  
reti

out_com:  ;   temp  . 
	sbis UCSRA,UDRE ;   
	rjmp out_com
	out	UDR,temp ;
ret


RESET: 
	ldi r16, low(RAMEND)
	out SPL,r16

ldi temp,0b00000011 ; B  PB0, PB1  
out DDRB,temp
sbi PortB,0 ; Led
;=====   
ldi temp,(1<<TOIE0)|(1<<TOIE1) ;. . Timer0  Timer1
out TIMSK,temp
clr temp

out TCNT1H,temp 
out TCNT1L,temp ; Timer1
out TCNT0,temp ; Timer0
ldi temp,(1<< PSR10);     . 1
out SFIOR,temp ;  PSR10  SFIOR (GTCCR)
clr data0 
clr data1 
clr data2 
clr Flag_out
clr count_0 ;  
;=== UART
	ldi temp, (1<<U2X) ; 
	out UCSRA,temp
	ldi temp,26 ;9600
	out	UBRRL,temp ;.    2097152 Hz 
	ldi temp,(1<<RXEN|1<<TXEN)
	out	UCSRB,temp ;. / 8
ldi temp,0b00000101;
out TCCR0B,temp ; Timer0 div 1:1024 
ldi temp,0b00000110 ;Timer1   1 (. 9 PD5)  
out TCCR1B,temp ; Timer1
sei

G_cykle:
   cpi Flag_out,$FF
   breq out1
rjmp G_cykle
out1:   
;    DK1
	ldi temp,'K' ; K
	rcall out_com ;    
	ldi temp,'D' ; D
	rcall out_com ; 
	ldi temp,'1' ; 1
	rcall out_com ; 
;	
		mov temp,data0
 		rcall out_com ; 
		mov temp,data1
 		rcall out_com ; 
		mov temp,data2
 		rcall out_com ; 
	ldi temp,';' ; ';',  
	rcall out_com ; 

	clr data2 ;  
	clr Flag_out
rjmp G_cykle


