  //Прием тестовых показаний частоты датчика РКТ-206
//прием НС-12, сигнатура KD1 

#define LedPin 13

#define RX 3 //Определяем вывод RX (TX на модуле)
#define TX 4 //Определяем вывод TX (RX на модуле)
#include <SoftwareSerial.h> //библиотека программного последовательного порта
SoftwareSerial Serialpr(RX,TX);           

volatile uint8_t bb;
volatile uint32_t value; //присланное значение частоты 
volatile uint8_t arr[8]; // {'K','D','1',0,0,0,';'}; 

volatile uint32_t f_frq[5]; //ttemp_SHT20[5]
volatile byte f_index=0; //t_index_SHT20
volatile uint32_t f_total=0; //ttotal_SHT20
uint32_t f_aver = 0;            //taver_SHT20 скользящее среднее
volatile boolean ini_avr = true; //ini_SHT20 начальн заполнение массива


void setup() {
  Serialpr.begin(9600);
  Serial.begin(9600);
  pinMode(LedPin,OUTPUT);
}

void loop() {
//====внешний датчик частота через HC-12
  if (Serialpr.available() > 0)
  {
   byte i = 0;
    while (Serialpr.available() > 0) {
      // Пришла! Считываем её и анализируем
      bb = Serialpr.read(); //мл. байт
      arr[i]=bb;
      delay(1);   
 //     Serial.print(bb,HEX); //для отладки
 //     Serial.print(' '); //для отладки
      i++;
    } // конец while
    if (bb == ';') { //если последний символ - конец данных
      if ((arr[0] == 'K') && (arr[1] == 'D') && (arr[2] == '1')) //если первые три символа = "KD1"
      { //тот самый датчик
        digitalWrite(LedPin,HIGH);
 // скользящее среднее
      // вычитаем последнее значение из суммы
        f_total = f_total - f_frq[f_index];
      // формируем трехбайтовое число в десятых долях герца
        value = long (arr[5]) * 256 * 256 +  long (arr[4]) * 256 + long(arr[3]); 
        f_frq[f_index]=value;
      // добавляем значение к сумме
         f_total = f_total + f_frq[f_index];
      // переставляем индекс на следующую позицию
         f_index = f_index + 1;
      // считаем среднее:
      if (ini_avr)  //первое заполнение массива
          f_aver = f_total / f_index;
      else  
          f_aver = f_total/5;
      // проверяем если мы выскочили индексом за пределы массива
      if (f_index >= 5) {
          // если да, то индекс на ноль
          f_index = 0;
          ini_avr = false; //закончили заполнение
          }
        {  Serial.print(f_aver); //выводим частоту
          Serial.println(' ');          
        }
       delay(500);
       digitalWrite(LedPin,LOW);
     } //end signature 
         //обнуляем массив
         for (byte i = 0; i < 7; i++) arr[i]=0;
    } //конец if bb
  } //конец Serialpr.available
} //end loop
